package com.persagy.calendar.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.persagy.calendar.pojo.dto.WorkCalendarDate;

/**
 * 工作历作息时间表，此表只有新增，无修改[新版]
 * 
 * @version 1.0.0
 * @company persagy 
 * @author zhangqiankun
 * @date 2020-10-03 13:54:22
 */
@Mapper
public interface WorkCalendarDateMapper extends BaseMapper<WorkCalendarDate> {

	/**
	 * 不存在新增，存在更新
	 * @param calendarDate
	 * @return
	 */
	Integer replaceIntoCalendarDate(WorkCalendarDate calendarDate);

	/**
	 * 批量创建自定义作息时间信息
	 * 
	 * @param datas
	 * @return
	 */
	Integer batchCreateCalendarDate(@Param("datas") List<WorkCalendarDate> datas);

}
