package com.persagy.calendar.mapper;

import java.util.Set;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.persagy.calendar.pojo.dto.WorkCalendarObject;

/**
 * @version 1.0.0
 * @company persagy 
 * @author zhangqiankun
 * @date 2020-10-02 18:26:14
 */
@Mapper
public interface WorkCalendarObjectMapper extends BaseMapper<WorkCalendarObject> {

	/**
	 * 批量插入对象关系数据
	 * @param object
	 * @param objIds
	 * @return
	 */
	Integer batchInsertObjects(@Param("object") WorkCalendarObject object, @Param("objIds") Set<String> objIds);

	/**
	 * 对象变更所属工作历
	 * @param calendarObject
	 * @param objIds 
	 * @return
	 */
	Integer replaceCalendarObject(@Param("calendarObject") WorkCalendarObject calendarObject, @Param("objIds") Set<String> objIds);

}
