package com.persagy.calendar.pojo.vo;

import java.util.Set;

import javax.validation.constraints.NotBlank;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * 注意，此类不能添加集团编码作为查询条件，因为规则解析需要解析所有集团下的规则，除非后续修改了xxl-job的规则解析功能
 * 
 * @version 
 * @description 
 * @company persagy
 * @author zhangqiankun
 * @since 2020年10月3日:	下午2:26:22
 */
@Getter
@Setter
@ToString
public class WorkCalendarDateQueryVO {
	
	@NotBlank(message = "用户ID不可为空")
	//@ApiModelProperty(value = "用户ID", required = true)
	private String userId;
	
	//@ApiModelProperty(name = "ID", value = "主键ID,更新时不可为空")
	private String id;

	//@ApiModelProperty(value = "集团编码", required = true)
	private String groupCode;  // 集团编码

	//@ApiModelProperty(value = "项目ID", required = true)
	private String projectId;  // 项目
	
	//@ApiModelProperty(value = "规则ID")
	private String ruleId; 		// 规则ID
	
	//@ApiModelProperty(value = "工作历ID")
	private String calendarId; // 工作历ID

	//@ApiModelProperty(value = "工作历名称")
	private String calendarName; // 工作历名称

	//@ApiModelProperty(value = "字典类型")
	private String dictType; // 字典类型
	
	//@ApiModelProperty(value = "字典类型")
	private Set<String> dictTypes; // 字典类型

	//@ApiModelProperty(value = "字典数据code")
	private Set<String> dictCode; // 字典数据code

	@NotBlank(message = "workDateStart不可为空[YYYYMMDD]")
	//@ApiModelProperty(value = "查询从此日开始的作息详情 [YYYYMMDD]")
	private String workDateStart; // 具体执行日期 YYYYMMDD
	
	@NotBlank(message = "workDateEnd不可为空[YYYYMMDD]")
	//@ApiModelProperty(value = "查询从此日结束的作息详情 [YYYYMMDD]")
	private String workDateEnd; // 具体执行日期 YYYYMMDD
	
	//@ApiModelProperty(value = "对象ID")
	private String objId; 		// 对象D 
	
}
