package com.persagy.calendar.pojo.vo;

import java.util.Set;

import javax.validation.constraints.NotBlank;

import com.persagy.calendar.constant.WorkCalendarConstant;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * @version 
 * @description 
 * @company persagy
 * @author zhangqiankun
 * @since 2020年10月3日:	下午2:26:22
 */
@Getter
@Setter
@ToString
public class WorkCalendarMoreDateCreateVO extends BaseVO {
	
	//@ApiModelProperty(value = "是否只删除此段日期下已存在的作息时间属性，重新添加，默认false")
	private Boolean isDelete;
	
	@NotBlank(message = "工作历ID，不可为空")
	//@ApiModelProperty(value = "工作历ID", required = true)
	private String calendarId; // 工作历ID
	
	@NotBlank(message = "字典类型，不可为空")
	//@ApiModelProperty(value = "字典类型", required = true)
	private String dictType; // 字典类型

	//@ApiModelProperty(value = "字典数据code")
	private String dictCode; // 字典数据code
	
	@NotBlank(message = "开始作息时间，不可为空")
	//@ApiModelProperty(value = "开始作息时间[YYYYMMDD]", required = true)
	private String workDateStart;

	@NotBlank(message = "结束作息时间，不可为空")
	//@ApiModelProperty(value = "结束作息时间[YYYYMMDD]", required = true)
	private String workDateEnd;

	//@NotEmpty(message = "作息时间点集合timetable，不可为空")
	//@ApiModelProperty(value = "作息时间点集合[HH:mm-HH:mm]", required = true)
	private Set<String> timetable;
	
	//@ApiModelProperty(value = "0-非自定义作息时间，1-自定义作息时间")
	private String customFlag = WorkCalendarConstant.CUSTOM_CALENDAR_DATE_YES; 	//默认自定义
	
}
