package com.persagy.dye.mapper;

import com.persagy.dye.pojo.vo.DyeScaleplateVO;
import org.apache.ibatis.annotations.Mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.persagy.dye.pojo.dto.DyeRuleCustom;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 染色规则自定义表
 * 
 * @version v1.0.0
 * @company persagy 
 * @author yangwanyi
 * @date 2021-10-25 15:58:56
 */
@Mapper
public interface DyeRuleCustomMapper extends BaseMapper<DyeRuleCustom> {

    /**
     * 查询指定集团、项目和类型的自定义染色标尺列表
     * @param dyeScaleplateVO
     * @return List<DyeRuleCustom>
     */
    List<DyeRuleCustom> listDyeRuleCustomByType(DyeScaleplateVO dyeScaleplateVO);

    /**
     * 获取指定集团、项目和类型和数值的自定义染色标尺
     * @param dyeScaleplateVO
     * @param numValue
     * @return DyeRuleCustom
     */
    DyeRuleCustom getDistrictDyeRuleCustom(@Param("dyeScaleplateVO") DyeScaleplateVO dyeScaleplateVO, @Param("numValue") Integer numValue);
}
